=== debian/changelog ===
passt (0.0~git20241030.ee7d0b6-1) unstable; urgency=medium

  * New upstream version 0.0~git20241030.ee7d0b6:
    - Fix occasional hang on TCP loopback path after the receiving
      buffer fills up:
        https://github.com/containers/podman/issues/24219
    - By default, don't expose loopback-only services in container:
        https://github.com/containers/podman/issues/24045
    - Add --dns-host option to configure host side nameserver:
        https://bugs.passt.top/show_bug.cgi?id=102
    - Add --frebind option to enable IP_FREEBIND on sockets:
        https://bugs.passt.top/show_bug.cgi?id=101

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 30 Oct 2024 13:29:54 +0100

passt (0.0~git20240906.6b38f07-1) unstable; urgency=medium

  * New upstream version 0.0~git20240906.6b38f07:
    - Fix possible EPOLLRDHUP event storms with half-closed TCP
      connections, leading to periods of high CPU load:
        https://github.com/containers/podman/issues/23686
        https://bugs.passt.top/show_bug.cgi?id=94
    - Fix possible EPOLLERR event storms with UDP flows:
        https://bugs.passt.top/show_bug.cgi?id=95

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 06 Sep 2024 16:09:07 +0200

passt (0.0~git20240821.1d6142f-1) unstable; urgency=medium

  * New upstream version 0.0~git20240821.1d6142f:
    - Allow currently needed set of system calls for i386 and armhf in
      seccomp profiles (Closes: #1078981)
    - Introduce --map-host-loopback and --map-guest-addr options to
      reach the host using arbitrary addresses, using either loopback
      or the guest/container address as source

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 21 Aug 2024 14:33:46 +0200
