=== debian/changelog ===
passt (0.0~git20241127.c0fbc7e-1) unstable; urgency=medium

  * New upstream version 0.0~git20241127.c0fbc7e:
    - Introduce "local mode" for disconnected setups:
      https://github.com/containers/podman/issues/24614
    - Add support for DHCP option 80 (Rapid Commit) and honour DHCP
      "broadcast" flag

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 27 Nov 2024 12:36:44 +0100

passt (0.0~git20241121.238c69f-1) unstable; urgency=medium

  * New upstream version 0.0~git20241121.238c69f:
    - Send periodic unsolicited router advertisements to avoid losing
      SLAAC routes after ~18 hours:
      https://github.com/kubevirt/kubevirt/issues/13191
    - Properly handle TCP keep-alive segments:
      https://github.com/containers/podman/discussions/24572

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 21 Nov 2024 08:37:29 +0100
