=== debian/changelog ===
passt (0.0~git20241211.09478d5-1) unstable; urgency=medium

  * New upstream version 0.0~git20241211.09478d5:
    - Add vhost-user support in passt (--vhost-user)
    - Add --no-splice switch to forcibly disable tap bypass path
    - Fix assertion on ping with ID 0:
      https://bugs.passt.top/show_bug.cgi?id=105
    - Avoid dynamic memory allocation (and seccomp terminating us)
      from strerror() in glibc > 2.40:
      https://github.com/containers/podman/issues/24804

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 12 Dec 2024 09:22:07 +0100
