=== debian/changelog ===
passt (0.0~git20250121.4f2c8e7-1) unstable; urgency=medium

  * New upstream version 0.0~git20250121.4f2c8e7:
    - Don't block UDP multicast and broadcast messages:
      https://github.com/containers/podman/issues/24871
    - Disable Nagle's algorithm on all TCP paths
    - Fix ASSERT() on vhost-user multi-buffer messages
    - Fix EPOLLIN event storm with repeated EAGAIN from socket
    - Add prototype for vhost-user-based migration
    - Set PSH flag at end of TCP batches:
      https://bugs.passt.top/show_bug.cgi?id=107

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 21 Jan 2025 16:39:46 +0100
