=== debian/changelog ===
passt (0.0~git20250217.a1e48a0-1) unstable; urgency=medium

  * New upstream version 0.0~git20250217.a1e48a0:
    - AppArmor workaround to allow libvirt to use passt
    - Option --host-ns-to-lo is not deprecated anymore:
      https://github.com/rootless-containers/rootlesskit/pull/482
    - Added support for --hostname and --fqdn (DHCP/DHCPv6) options
    - Fix wakeup loop in pasta's loopback path when receiver is full:
      https://github.com/containers/podman/issues/23686#issuecomment-2661036584
    - Add migration support via vhost-user, TCP connections preserved

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 17 Feb 2025 09:21:39 +0100
