=== debian/control ===
Source: passt
Section: net
Priority: optional
Maintainer: Stefano Brivio <sbrivio@redhat.com>
Build-Depends: debhelper-compat (= 13), dh-apparmor
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://passt.top/
Vcs-Browser: https://salsa.debian.org/sbrivio/passt
Vcs-Git: https://salsa.debian.org/sbrivio/passt.git

Package: passt
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: apparmor
Description: user-mode networking daemons for virtual machines and namespaces
 passt implements a translation layer between a Layer-2 network interface and
 native Layer-4 sockets (TCP, UDP, ICMP/ICMPv6 echo) on a host. It doesn't
 require any capabilities or privileges, and it can be used as a simple
 replacement for Slirp.
 .
 pasta (same binary as passt, different command) offers equivalent
 functionality, for network namespaces: traffic is forwarded using a tap
 interface inside the namespace, without the need to create further interfaces
 on the host, hence not requiring any capabilities or privileges.
