## passt 0.0~git20250320.32f6212

=== debian/changelog ===
passt (0.0~git20250320.32f6212-1) unstable; urgency=medium

  * debian/rules: Install passt-repair profile using dh_apparmor
  * control: Update standards version to 4.7.2
  * New upstream version 0.0~git20250320.32f6212:
    - Fix possible transfer loop in short TCP exchange,
      https://bugs.passt.top/show_bug.cgi?id=114
    - Several fixes for passt-repair and guest migration,
      including https://bugs.passt.top/show_bug.cgi?id=115
    - build and send ICMP and ICMPv6 messages to guest for a number
      of error conditions

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 20 Mar 2025 13:14:03 +0100
