=== debian/changelog ===
passt (0.0~git20250503.587980c-2) unstable; urgency=high

  * Fix potential failed assertion on outbound broadcast packets

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 14 May 2025 17:00:48 +0200

passt (0.0~git20250503.587980c-1) unstable; urgency=medium

  * New upstream version 0.0~git20250503.587980c:
    - Fix potential assertion trigger on heavy UDP traffic,
      https://github.com/containers/podman/issues/25959
    - Fix potential infinite loop while handling multicast
      traffic

 -- Stefano Brivio <sbrivio@redhat.com>  Sun, 04 May 2025 11:43:12 +0200
