=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 endif
 	dh_apparmor --profile-name=usr.bin.passt -ppasst
 	dh_apparmor --profile-name=usr.bin.pasta -ppasst
+	dh_apparmor --profile-name=usr.bin.passt-repair -ppasst
 
 ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
 override_dh_link:
