## passt 0.0~git20250911.6cbcccc

=== debian/changelog ===
passt (0.0~git20250911.6cbcccc-1) unstable; urgency=medium

  * New upstream version 0.0~git20250911.6cbcccc

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 11 Sep 2025 17:47:57 +0200
