## passt 0.0~git20250919.623dbf6

=== test/Makefile ===
--- 
+++ 
@@ -5,6 +5,8 @@
 # Copyright Red Hat
 # Author: David Gibson <david@gibson.dropbear.id.au>
 
+BATS = bats -j $(shell nproc)
+EXETOOL = exeter/exetool/exetool
 WGET = wget -c
 
 DEBIAN_IMGS = debian-8.11.0-openstack-amd64.qcow2 \
@@ -13,7 +15,7 @@
 	debian-10-generic-ppc64el-20220911-1135.qcow2 \
 	debian-11-nocloud-amd64.qcow2 \
 	debian-11-generic-arm64.qcow2 \
-	debian-11-generic-ppc64el.qcow2 \
+	debian-11-generic-ppc64el-20250703-2162.qcow2 \
 	debian-sid-nocloud-amd64-daily.qcow2 \
 	debian-sid-nocloud-arm64-daily.qcow2 \
 	debian-sid-nocloud-ppc64el-daily.qcow2
@@ -50,17 +52,23 @@
 	jammy-server-cloudimg-s390x.img
 UBUNTU_IMGS = $(UBUNTU_OLD_IMGS) $(UBUNTU_NEW_IMGS)
 
-DOWNLOAD_ASSETS = mbuto podman \
+DOWNLOAD_ASSETS = exeter mbuto podman \
 	$(DEBIAN_IMGS) $(FEDORA_IMGS) $(OPENSUSE_IMGS) $(UBUNTU_IMGS)
 TESTDATA_ASSETS = small.bin big.bin medium.bin \
 	rampstream
 LOCAL_ASSETS = mbuto.img mbuto.mem.img podman/bin/podman QEMU_EFI.fd \
 	$(DEBIAN_IMGS:%=prepared-%) $(FEDORA_IMGS:%=prepared-%) \
 	$(UBUNTU_NEW_IMGS:%=prepared-%) \
-	nstool guest-key guest-key.pub \
+	nstool guest-key guest-key.pub $(EXETOOL) \
 	$(TESTDATA_ASSETS)
 
 ASSETS = $(DOWNLOAD_ASSETS) $(LOCAL_ASSETS)
+
+EXETER_PYPATH = exeter/py3
+EXETER_BATS = smoke/smoke.sh.bats \
+	build/build.py.bats build/static_checkers.sh.bats
+BATS_FILES = $(EXETER_BATS) \
+	podman/test/system/505-networking-pasta.bats
 
 CFLAGS = -Wall -Werror -Wextra -pedantic -std=c99
 
@@ -69,6 +77,11 @@
 .PHONY: pull-%
 pull-%: %
 	git -C $* pull
+
+exeter:
+	git clone https://gitlab.com/dgibson/exeter.git
+
+exeter/exetool/exetool: pull-exeter
 
 mbuto:
 	git clone git://mbuto.sh/mbuto
@@ -115,6 +128,12 @@
 big.bin:
 	dd if=/dev/urandom bs=1M count=10 of=$@
 
+$(EXETER_BATS): %.bats: % $(EXETOOL)
+	PYTHONPATH=$(EXETER_PYPATH) $(EXETOOL) bats -- $< > $@
+
+bats: $(BATS_FILES) pull-podman
+	PYTHONPATH=$(EXETER_PYPATH) CONTAINERS_HELPER_BINARY_DIR=.. $(BATS) $(BATS_FILES)
+
 check: assets
 	./run
 
@@ -124,6 +143,7 @@
 clean:
 	rm -f perf.js *~
 	rm -f $(LOCAL_ASSETS)
+	rm -f $(EXETER_BATS)
 	rm -rf test_logs
 	rm -f prepared-*.qcow2 prepared-*.img
 
@@ -149,6 +169,9 @@
 debian-11-generic-%.qcow2:
 	$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/latest/debian-11-generic-$*.qcow2
 
+debian-11-generic-ppc64el-20250703-2162.qcow2:
+	$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/20250703-2162/debian-11-generic-ppc64el-20250703-2162.qcow2
+
 debian-sid-nocloud-%-daily.qcow2:
 	$(WGET) -O $@ https://cloud.debian.org/images/cloud/sid/daily/latest/debian-sid-nocloud-$*-daily.qcow2
