=== debian/changelog ===
passt (0.0~git20250919.623dbf6-1) unstable; urgency=medium

  * New upstream version 0.0~git20250919.623dbf6:
    - Send initial ARP and NDP requests on new connection to guest
    - When pasta(1) copies routes, clear nexthop state flags as they
      lead to insertion errors in some common cases (e.g. linkdown)

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 19 Sep 2025 23:20:55 +0200
