=== debian/watch ===
version=4
options="uversionmangle=s/_//g; s/^/0.0~git/" \
https://passt.top/passt/ /passt/snapshot/@PACKAGE@-([0-9]{4}_[0-9]{2}_[0-9]{2}.[0-9a-f]{7})@ARCHIVE_EXT@
